To reproduce our experiments on ANN-benchmarks, there are three tools that must be run:

construct - creates a near neighbor index from an NPY data file
reorder - applies graph reordering to permute the node ordering of the index
query - queries the index and computes recall and other performance

The tools are self-documenting and will provide help if run without any command line arguments. To build the tools, you will need the g++ compiler and Make utility. Given those, run

``` make <tool_name>```

To generate these NPY files from the HDF5 files provided by ANN-benchmarks, you may use the Python script dump.py, as follows

```python dump.py dataset.hdf5```


For our larger experiments with SIFT1B and DEEP1B, first download the dataset using the links provided in the supplementary PDF. Then, run the specialized ```sift_construct``` and ```sift_query``` tools (the reordering tool works fine on any index)
